class Product:
    def __init__(self, name, price, stock):
        self.name = name
        self.price = price
        self.stock = stock

class VendingMachine():
    def __init__(self):
        self.products = {
            "A1": Product("cola", 2, 3),
            "A2": Product("chip", 1, 1)
            }
        self.balance = 0
        self.state = "IDLE"

    def insert_coin(self, amount):
        if self.state in ["IDLE", "SELECTING"]:
            self.balance += amount
            self.state = "SELECTING"
            print(self.balance)
        else:
            print("Cannot insert coin now")
                
    def select_item(self, code):
        if self.state != "SELECTING":
            print("Please insert money first")
            return

        if code not in self.products:
            print("Invalid code")
            return

        item = self.products[code]
        if item.stock <= 0:
            print("Item out of stock")
            return

        if self.balance < item.price:
            print("Not enough $")
            return

        self.state = "DISPENSING"
        self.dispense(code)     

    def dispense(self, code):
        item = self.products[code]
        self.balance -= item.price
        item.stock -= 1
        print("Dispensing", item.name)
        print("Change:", self.balance)
        self.balance = 0
        self.state = "IDLE"
            
